Merge branch 'fixes' of git://git.armlinux.org.uk/~rmk/linux-arm
[deliverable/linux.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0
SR
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
a7df4716 65 -lutil -lrt -lpthread ${1}
1f2bfbd0
SR
66 rm -f linux
67 fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74 info KSYM ${2}
75 local kallsymopt;
76
b92021b0
RR
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
6895f97e
JH
79 fi
80
1f2bfbd0 81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 82 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
83 fi
84
cc847530 85 if [ -n "${CONFIG_ARM}" ] && [ -z "${CONFIG_XIP_KERNEL}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
7122c3e9
ML
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
87 fi
f6537f2f 88
4d5d5664 89 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
90 kallsymopt="${kallsymopt} --absolute-percpu"
91 fi
92
2213e9a6
AB
93 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
94 kallsymopt="${kallsymopt} --base-relative"
95 fi
96
00e6c28c
SR
97 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
98 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 99
a0439342
AB
100 local afile="`basename ${2} .o`.S"
101
102 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
103 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
104}
105
106# Create map file with all symbols from ${1}
107# See mksymap for additional details
108mksysmap()
109{
110 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
111}
112
1347a2ce
LT
113sortextable()
114{
115 ${objtree}/scripts/sortextable ${1}
116}
117
1f2bfbd0 118# Delete output files in case of error
1f2bfbd0
SR
119cleanup()
120{
121 rm -f .old_version
122 rm -f .tmp_System.map
123 rm -f .tmp_kallsyms*
124 rm -f .tmp_version
125 rm -f .tmp_vmlinux*
126 rm -f System.map
127 rm -f vmlinux
128 rm -f vmlinux.o
129}
130
ab160dbb
SB
131on_exit()
132{
133 if [ $? -ne 0 ]; then
134 cleanup
135 fi
136}
137trap on_exit EXIT
138
139on_signals()
140{
141 exit 1
142}
143trap on_signals HUP INT QUIT TERM
144
1f2bfbd0
SR
145#
146#
147# Use "make V=1" to debug this script
148case "${KBUILD_VERBOSE}" in
149*1*)
150 set -x
151 ;;
152esac
153
154if [ "$1" = "clean" ]; then
155 cleanup
156 exit 0
157fi
158
159# We need access to CONFIG_ symbols
423a8155
MM
160case "${KCONFIG_CONFIG}" in
161*/*)
162 . "${KCONFIG_CONFIG}"
163 ;;
164*)
165 # Force using a file from the current directory
166 . "./${KCONFIG_CONFIG}"
167esac
1f2bfbd0
SR
168
169#link vmlinux.o
170info LD vmlinux.o
171modpost_link vmlinux.o
172
173# modpost vmlinux.o to check for section mismatches
174${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
175
176# Update version
177info GEN .version
178if [ ! -r .version ]; then
179 rm -f .version;
180 echo 1 >.version;
181else
182 mv .version .old_version;
183 expr 0$(cat .old_version) + 1 >.version;
184fi;
185
186# final build of init/
187${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
188
189kallsymso=""
190kallsyms_vmlinux=""
191if [ -n "${CONFIG_KALLSYMS}" ]; then
192
193 # kallsyms support
194 # Generate section listing all symbols and add it into vmlinux
195 # It's a three step process:
196 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
197 # but __kallsyms is empty.
198 # Running kallsyms on that gives us .tmp_kallsyms1.o with
199 # the right size
200 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
201 # the right size, but due to the added section, some
202 # addresses have shifted.
203 # From here, we generate a correct .tmp_kallsyms2.o
204 # 2a) We may use an extra pass as this has been necessary to
205 # woraround some alignment related bugs.
206 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
207 # 3) The correct ${kallsymso} is linked into the final vmlinux.
208 #
209 # a) Verify that the System.map from vmlinux matches the map from
210 # ${kallsymso}.
211
212 kallsymso=.tmp_kallsyms2.o
213 kallsyms_vmlinux=.tmp_vmlinux2
214
215 # step 1
216 vmlinux_link "" .tmp_vmlinux1
217 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
218
219 # step 2
220 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
221 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
222
223 # step 2a
224 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
225 kallsymso=.tmp_kallsyms3.o
226 kallsyms_vmlinux=.tmp_vmlinux3
227
228 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
229
230 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
231 fi
232fi
233
234info LD vmlinux
235vmlinux_link "${kallsymso}" vmlinux
236
1347a2ce
LT
237if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
238 info SORTEX vmlinux
239 sortextable vmlinux
240fi
241
1f2bfbd0
SR
242info SYSMAP System.map
243mksysmap vmlinux System.map
244
245# step a (see comment above)
246if [ -n "${CONFIG_KALLSYMS}" ]; then
247 mksysmap ${kallsyms_vmlinux} .tmp_System.map
248
249 if ! cmp -s System.map .tmp_System.map; then
5369f550 250 echo >&2 Inconsistent kallsyms data
367e43c5 251 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
252 exit 1
253 fi
254fi
255
256# We made a new kernel - delete old version file
257rm -f .old_version
This page took 0.164429 seconds and 5 git commands to generate.